##### 3xBot.tcl - TripleX <daniel.bleisteiner@berlin.de>
#####
##### 2000-01-14 : v0.01 + trying to replace .adduser
##### 2000-01-26 : v0.02 + 3xCheckPassword
##### 2000-01-27 : v0.03 + 3xLockTopic
#####                    + 3xUnlockTopic
#####                    + 3xResetTopic
##### 2000-02-06 : v0.04 * different small Things
##### 2000-02-09 : v0.05 + !topic Function
#####                    + Function to compare Users Rights
#####                    + Comparsion of Rights to TopicFunctions
##### 2000-02-10 : v0.06 + !ltopic instead of !locktopic and !unlocktopic
#####                      !topic sets normal, !ltopic sets locked Topic
#####                      Locked Topic can't be overwritten by Users with less Rights
#####                      Locked Topic is marked via @ at the End
##### 2000-02-11 : v0.07 + first Stats
#####                    + VoteSystem
#####                    + NoteSystem to send to all Users with certain Flags
#####                    + HelpFile
##### 2000-02-17 : v0.08 - working on Stats
##### 2000-02-25 : v0.09 + TopChatter
#####                    + Reset for Stats
##### 2000-02-27 : v0.10 + TopWords
##### 2000-02-28 : v0.11 + Replacement of dangerous Chars
#####                    + Remove of dangerous Chars
#####                    * Stats
#####                    + TopIdler
#####                    * Stats ignoring Bots
##### 2000-02-29 : v0.12 + simple CheatProtection to Stats
#####                    + UsageSwitches
#####                    + TimerCheck for public Commands
##### 2000-02-29 : v0.13 + Channels to ignore for Topic
#####                    + Channels to ignore for Stats
#####                    * Topic for allready joined Channels
#####                    + MasterCheck to TimerCheck
##### 2000-02-29 : v0.14 + first Version of !url
#####                    * Topic-Init only triggering when 3xUseTopic is set to 1
#####                    + Commands !url, !clan, !server, !email, !icq, !what and !country
#####                             to search single Databases
#####                    + !add to support the above Commands
#####                    + simple !help
#####                    + .addentry to extend the Database
#####                    + .delentry to shorten the Database
##### 2000-03-01 : v0.15 * Stats messing up on { or [ or \ in Nick
#####                    + linked Bots to Channel Procs
##### 2000-03-05 : v0.16 + !url and Co for Query
#####                    * .addentry and .delentry for global Masters only
#####                    + Removes all ColorCodes and Co. for Stats
#####                    * Error in 3xSearchDatabase
##### 2000-03-06 : v0.17 * .addentry to strip [ { and Co.
#####                    + BackUp for .addentry and .delentry
#####                    * 3xReplaceDangerousChars not replacing leading ] and trailing [
#####                    * Div/0 in some initial !stats
#####                    + Logging to Vote
#####                    + Ignore of Bots for PasswordCheck
#####                    * 3xCompareFlags using [matchattr ...]
#####                    * TimeString sometimes messed up
#####                    * double LineFeed in VoteLog
##### 2000-03-08 : v0.18 * Stats through using a Hash for Nicks
#####                    + Ignore for Bots on Votes
#####                    + CGI to display older Votes on WWW
##### 2000-03-11 : v0.19 + Nick to !add Notes
#####                    * MissSpelling in Votes
#####                    * !ltopic loosing Nick on TopicRestore
#####                    * trailing LineFeeds removed from DBs to avoid empty Lines
#####                    * !email Bug
#####                    * TimeString to be more generell
##### 2000-03-11 : v0.20 + Check for a valid Vote-Question
#####                    + !mystats
#####                    + Notice in Query in Message that too many Entries matched
#####                    * empty Args an !add
##### 2000-03-16 : v0.21 + Kick for too much ColorCodes
##### 2000-03-16 : v1.00 * SyntaxError in matchattr
#####                    - first non-beta Release of this Script!
##### 2000-03-16 : v1.01 * BotCheck in Stats
#####                    + Channel to LogMsg for ColorKick
##### 2000-03-23 : v1.02 + !calc as public Command
#####                    + Display of first Entries if more then max are found
#####                    * wrong Handling of "?" in !clan & Co.
##### 2000-04-01 : v1.03 + ?topic to get Infos on ChannelTopic
#####                    * Overhead in !topic
#####                    * all english Language
#####                    + TimerCheck for TopicCommands
#####                    * corrected TimerCheck for Calc
##### 2000-04-02 : v1.04 * removed Nick from Topic
#####                    * made ?topic more accurate
#####                    * merging Notices in single Lines to speed up MsgQueue
##### 2000-04-11 : v1.05 + adding !idle
#####                    * completed !help Output
#####                    * completed 3xBot.help File
##### 2000-04-11 : v1.06 * fixing !idle Response on BotNick
#####                    + making Vote work with different Channels at the same Time
#####                    * changed VoteFlag to f|f
#####                    * reworking Vote via Query to support multiple Channels
#####                    * fixing TimerCheck for Stats and MyStats
##### 2000-04-21 : v1.07 + adding AutoVote on StatsReset
##### 2000-04-24 : v1.08 * using UserFlag +V for VoteCommand
#####                    * adding 1 Minute to StatsVote to get the desired Timing
#####                    * fixing StatsVote if Channel gets disabled while running
#####                    * changing !vote to work with different RunningTimes
#####                    * adding VoteTime, Nick and Host to LogFile
#####                    * changing votes.cgi to display these new Infos
#####                    + adding .killvote and .stopvote for Masters
#####                    + making Bots sync their !database on .addentry and .delentry
#####                    * giving ErrorMsgs only to calling Handle on PartyLine
##### 2000-04-29 : v1.09 * tweaking ?topic a bit more
#####                    * tweaking AutoStatsVote Timing
#####                    * adding db.cgi to make Databases accessable through WWW
#####                    * makeing .resetstats a bit safer
#####                    * fixing AutoStatsVote not working in different Channels!
#####                    * fixed .addentry and .delentry throwing Errors on missing linked Bots
##### 2000-04-29 : v1.10 * fixed AutoStatsVote - sorry
##### 2000-05-12 : v1.11 + adding WordList to ignore for TopWords in Stats
#####                    + made minimal WordLength for TopWords a Variable
#####                    * fixed StatsVote again
##### 2000-06-14 : v1.12 * fixing ColorKick if Bot got no @
#####                    * fixing TCL Error in StatsVote



##### Set the following Variables to affect the Features of this Script.
##### All Stuff after this Block should be left untouched!
set 3xUsePasswordCheck 1
set 3xUseTopic 1
  set 3xTopicTimerCheck "2:5"
  set 3xTopicIgnoreChannels {#dummy1 #dummy2}
  set 3xTopicLinkedBots {Dummy1 Dummy2}
set 3xUseStats 1
  set 3xStatsTimeForIgnore 15
  set 3xStatsTimerCheck "1:30"
  set 3xStatsForUserTimerCheck "3:5"
  set 3xStatsIgnoreChannels {#dummy1 #dummy2}
  set 3xStatsLinkedBots {Dummy1 Dummy2}
  set 3xStatsIgnoreWords {!* http://* www.* *:*}
  set 3xStatsMinWordLength 6
  set 3xUseStatsAutoVote 1
    set 3xStatsAutoVoteTimer 1440
    set 3xStatsAutoVoteIgnoreChannels {#dummy1 #dummy2}
set 3xUseVote 1
  set 3xVoteLinkedBots {Dummy1 Dummy2}
  set 3xVoteLogfile "./data/3xVotes.log"
set 3xUseMassNote 1
set 3xUseColorKick 1
  set 3xColorKickMaxColors 3
  set 3xColorKickIgnoreChannels {#dummy1 #dummy2}
set 3xUseCalc 1
  set 3xCalcTimerCheck "2:3"
  set 3xCalcKickIgnoreChannels {#dummy1 #dummy2}
  set 3xCalcLinkedBots {Dummy1 Dummy2}
set 3xUseIdle 1
  set 3xIdleTimerCheck "2:3"
  set 3xIdleKickIgnoreChannels {#dummy1 #dummy2}
  set 3xIdleLinkedBots {Dummy1 Dummy2}

##### These Settings affect !url, !clan, !email, !icq, !server, !country and !what
##### You can enable every single Command. The AccessTimer used for ChannelProtection
##### is the same for all of these. Also the maximum Number of displayed Entries is global
##### for all of them. But you can specify different Channels for Ignore for every Command!
##### You can also enable the NotificationFeature which allows Users to !add new Entries which
##### will be stored as Notes for the NoticifationHandle!
set 3xDatabaseLinkedBots {Dummy1 Dummy2}
set 3xMaxEntriesToShowInChannel 3
set 3xMaxEntriesToShowInQuery 15
set 3xDatabaseTimerCheck "2:3"
set 3xUseAddNotification 1
  set 3xNotificationHandle "NotesHandle"
  set 3xNotificationLinkedBots {Dummy1 Dummy2}
set 3xUseUrl 1
  set 3xUrlIgnoreChannels {#dummy1 #dummy2}
  set 3xUrlLinkedBots {Dummy1 Dummy2}
  set 3xFileUrl "./data/3xUrls.db"
set 3xUseClan 1
  set 3xClanIgnoreChannels {#dummy1 #dummy2}
  set 3xClanLinkedBots {Dummy1 Dummy2}
  set 3xFileClan "./data/3xClans.db"
set 3xUseEmail 1
  set 3xEmailIgnoreChannels {#dummy1 #dummy2}
  set 3xEmailLinkedBots {Dummy1 Dummy2}
  set 3xFileEmail "./data/3xEmails.db"
set 3xUseIcq 1
  set 3xIcqIgnoreChannels {#dummy1 #dummy2}
  set 3xIcqLinkedBots {Dummy1 Dummy2}
  set 3xFileIcq "./data/3xIcq.db"
set 3xUseServer 1
  set 3xServerIgnoreChannels {#dummy1 #dummy2}
  set 3xServerLinkedBots {Dummy1 Dummy2}
  set 3xFileServer "./data/3xServer.db"
set 3xUseCountry 1
  set 3xCountryIgnoreChannels {#dummy1 #dummy2}
  set 3xCountryLinkedBots {Dummy1 Dummy2}
  set 3xFileCountry "./data/3xCountries.db"
set 3xUseWhat 1
  set 3xWhatIgnoreChannels {#dummy1 #dummy2}
  set 3xWhatLinkedBots {Dummy1 Dummy2}
  set 3xFileWhat "./data/3xWhat.db"
set 3xUseHelp 1
  set 3xHelpLinkedBots {Dummy1 Dummy2}



###################################################################################################
###################################################################################################
###################################################################################################



##### Some global Variables!
set 3xLogo \002\|\002\003123xBot\003\002\|\002

##### Reminds Users to set a Password if they didn't so far!
proc 3xCheckPassword {nick uhost handle chan} {
  global 3xLogo botnick
  if {[matchattr $handle +b]} { return }
  if {[passwdok $handle ""]} {
    puthelp "NOTICE $nick :I don't have a Password from you yet! Use /msg $botnick PASS <password> to set yours!"
    putlog "$3xLogo <=> Reminded $nick ($handle) to set a Password!"
  }
}
if {$3xUsePasswordCheck} {
  bind JOIN -|- * 3xCheckPassword
}

##### The following handles the ChannelCommands !topic and !ltopic
##### which can be used by all Users in a Channel. Their Meaning is
##### self-explaining. Users with more or equal Rights can overwrite
##### locked Topics of others!
proc 3xInitTopicChannel {nick uhost handle chan} {
  global 3xLogo 3xCurrentTopic 3xTopicLocked 3xTopicLockedByNick 3xTopicLockedByHandle botnick 3xTopicIgnoreChannels 3xTopicSetByNick 3xTopicSetByUser 3xTopicSetAtTime
  if {$nick == $botnick} {
    if {![info exists 3xCurrentTopic([string tolower $chan])]} {
      set 3xCurrentTopic([string tolower $chan]) ""
    }
    if {![info exists 3xTopicLocked([string tolower $chan])]} {
      set 3xTopicLocked([string tolower $chan]) 0
    }
    if {![info exists 3xTopicLockedByNick([string tolower $chan])]} {
      set 3xTopicLockedByNick([string tolower $chan]) ""
    }
    if {![info exists 3xTopicLockedByHandle([string tolower $chan])]} {
      set 3xTopicLockedByHandle([string tolower $chan]) ""
    }
    if {![info exists 3xTopicSetByNick([string tolower $chan])]} {
      set 3xTopicSetByNick([string tolower $chan]) ""
    }
    if {![info exists 3xTopicSetByUser([string tolower $chan])]} {
      set 3xTopicSetByUser([string tolower $chan]) ""
    }
    if {![info exists 3xTopicSetAtTime([string tolower $chan])]} {
      set 3xTopicSetAtTime([string tolower $chan]) [clock seconds]
    }
  }
}
proc 3xSetTopic {nick user handle channel topic} {
  global 3xLogo 3xTopicLocked 3xCurrentTopic 3xTopicLockedByNick 3xTopicLockedByHandle 3xTopicIgnoreChannels 3xTopicLinkedBots 3xTopicSetByNick 3xTopicSetByUser 3xTopicSetAtTime 3xTopicTimerCheck

  if {[lsearch -exact [string tolower $3xTopicIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xTopicLinkedBots { if {[handonchan $bot $channel]} { return } }
  
  if {![3xCheckTimer $channel topic [lindex [split $3xTopicTimerCheck :] 0] [lindex [split $3xTopicTimerCheck :] 1] $nick $handle]} { return }

  if (![botisop $channel]) { return 0 }
  if {$3xTopicLocked([string tolower $channel]) == 1} {
    if {![3xCompareFlags $handle $3xTopicLockedByHandle([string tolower $channel]) $channel]} {
      puthelp "NOTICE $nick :This Topic got locked by $3xTopicLockedByNick([string tolower $channel])"
      putlog "$3xLogo <=> $nick ($handle) tries to change locked Topic in [string tolower $channel]!"
      return 0
    }
    set 3xTopicLocked([string tolower $channel]) 0
    puthelp "NOTICE $nick :Topic unlocked on [string tolower $channel]!"
  }
  set 3xTopicSetByNick([string tolower $channel]) $nick
  set 3xTopicSetByUser([string tolower $channel]) [maskhost $user]
  set 3xTopicSetAtTime([string tolower $channel]) [clock seconds]
  puthelp "TOPIC $channel :$topic"
  putlog "$3xLogo <=> $nick ($handle) sets Topic in [string tolower $channel]!"
}
proc 3xLockTopic {nick user handle channel topic} {
  global 3xLogo 3xTopicLocked 3xCurrentTopic 3xTopicLockedByNick 3xTopicLockedByHandle 3xTopicIgnoreChannels 3xTopicLinkedBots 3xTopicSetByNick 3xTopicSetByUser 3xTopicSetAtTime 3xTopicTimerCheck

  if {[lsearch -exact [string tolower $3xTopicIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xTopicLinkedBots { if {[handonchan $bot $channel]} { return } }

  if {![3xCheckTimer $channel topic [lindex [split $3xTopicTimerCheck :] 0] [lindex [split $3xTopicTimerCheck :] 1] $nick $handle]} { return }

  if (![botisop $channel]) { return 0 }
  if {$3xTopicLocked([string tolower $channel]) == 1} {
    if {![3xCompareFlags $handle $3xTopicLockedByHandle([string tolower $channel]) $channel]} {
      puthelp "NOTICE $nick :This Topic got locked by $3xTopicLockedByNick([string tolower $channel])"
      putlog "$3xLogo <=> $nick ($handle) tries to change locked Topic in [string tolower $channel]!"
      return 0
    }
  }
  set 3xCurrentTopic([string tolower $channel]) $topic
  set 3xTopicLocked([string tolower $channel]) 1
  set 3xTopicLockedByNick([string tolower $channel]) $nick
  set 3xTopicLockedByHandle([string tolower $channel]) $handle
  set 3xTopicSetByNick([string tolower $channel]) $nick
  set 3xTopicSetByUser([string tolower $channel]) [maskhost $user]
  set 3xTopicSetAtTime([string tolower $channel]) [clock seconds]
  puthelp "TOPIC $channel :$topic @"
  puthelp "NOTICE $nick :Topic locked on [string tolower $channel]!"
  putlog "$3xLogo <=> $nick ($handle) sets locked Topic in [string tolower $channel]!"
}
proc 3xInfoTopic {nick user handle channel topic} {
  global 3xLogo 3xTopicLocked 3xCurrentTopic 3xTopicLockedByNick 3xTopicLockedByHandle 3xTopicIgnoreChannels 3xTopicLinkedBots 3xTopicSetByNick 3xTopicSetByUser 3xTopicSetAtTime 3xTopicTimerCheck

  if {[lsearch -exact [string tolower $3xTopicIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xTopicLinkedBots { if {[handonchan $bot $channel]} { return } }
  
  if {![3xCheckTimer $channel topic [lindex [split $3xTopicTimerCheck :] 0] [lindex [split $3xTopicTimerCheck :] 1] $nick $handle]} { return }

  if {[string length $3xTopicSetByNick([string tolower $channel])] > 0} {
    puthelp "PRIVMSG $channel :$3xLogo Topic set by $3xTopicSetByNick([string tolower $channel]) ($3xTopicSetByUser([string tolower $channel])), [3xGetTimeString [expr [clock seconds] - $3xTopicSetAtTime([string tolower $channel])]] ago!"
  }
  if {[string length $3xTopicSetByNick([string tolower $channel])] == 0} {
    puthelp "PRIVMSG $channel :$3xLogo Sorry, I don't know who set this Topic!"
  }
  putlog "$3xLogo <=> $nick ($handle) asks for TopicInfo in [string tolower $channel]!"
}
proc 3xResetTopic {nick user handle channel topic} {
  global botnick 3xLogo 3xTopicLocked 3xCurrentTopic 3xTopicLockedByNick 3xTopicLockedByHandle 3xTopicIgnoreChannels 3xTopicLinkedBots 3xTopicSetByNick 3xTopicSetByUser 3xTopicSetAtTime

  if {$nick == $botnick} { return 0 }
  if {$nick == "*"} { return 0 }

  if {$3xTopicLocked([string tolower $channel]) != 1} {
    set 3xTopicSetByNick([string tolower $channel]) $nick
    set 3xTopicSetByUser([string tolower $channel]) [maskhost $user]
    set 3xTopicSetAtTime([string tolower $channel]) [clock seconds]
  }
  
  if {[lsearch -exact [string tolower $3xTopicIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xTopicLinkedBots { if {[handonchan $bot $channel]} { return } }

  if (![botisop $channel]) { return 0 }
  if {$3xTopicLocked([string tolower $channel]) == 1} {
    if {[3xCompareFlags $handle $3xTopicLockedByHandle([string tolower $channel]) $channel]} {
      set 3xTopicLocked([string tolower $channel]) 0
      puthelp "NOTICE $nick :Topic unlocked on [string tolower $channel]!"
      set 3xTopicSetByNick([string tolower $channel]) $nick
      set 3xTopicSetByUser([string tolower $channel]) [maskhost $user]
      set 3xTopicSetAtTime([string tolower $channel]) [clock seconds]
      putlog "$3xLogo <=> $nick ($handle) sets Topic in [string tolower $channel]!"
      return 0
    }
    puthelp "TOPIC $channel :$3xCurrentTopic([string tolower $channel]) @"
    puthelp "NOTICE $nick :This Topic got locked by $3xTopicLockedByNick([string tolower $channel])"
    putlog "$3xLogo <=> $nick ($handle) tries to change locked Topic in [string tolower $channel]! Reset Topic!"
    return 0
  }
  set 3xTopicSetByNick([string tolower $channel]) $nick
  set 3xTopicSetByUser([string tolower $channel]) [maskhost $user]
  set 3xTopicSetAtTime([string tolower $channel]) [clock seconds]
  putlog "$3xLogo <=> $nick ($handle) sets Topic in [string tolower $channel]!"
}
if {$3xUseTopic} {
  set tmpChans [channels]
  foreach {c} $tmpChans {
    3xInitTopicChannel $botnick dummy dummy $c
  }
  bind PUB -|- !topic 3xSetTopic
  bind PUB -|- !ltopic 3xLockTopic
  bind PUB -|- ?topic 3xInfoTopic
  bind TOPC -|- * 3xResetTopic
  bind JOIN -|- * 3xInitTopicChannel
}

##### The following deals with all the Stats. The Bot counts the Number
##### of Words everbody says and generates some simple Stats out of this!
proc 3xUpdateStats {nick user handle channel msg} {
  global 3xLogo 3xStatsNumberOfWordsInChannel 3xStatsStarted 3xStatsWordsOfUsersInChannel 3xStatsWordsInChannel 3xStatsUsersOnIgnoreInChannel 3xStatsTimeForIgnore 3xStatsIgnoreChannels 3xStatsNicksForHosts 3xUseStatsAutoVote 3xStatsAutoVoteTimer 3xStatsAutoVoteIgnoreChannels 3xStatsIgnoreWords 3xStatsMinWordLength

  ##### Ignore defined Channels!
  if {[lsearch -exact [string tolower $3xStatsIgnoreChannels] [string tolower $channel]] > -1} { return }

  ##### Make Channel lower-case!
  set channel [string tolower $channel]

  ##### Filter all ColorCodes and Co!
  set msg [3xRemoveColorCodesAndCo $msg]

  ##### Check for initialized Variables!
  if {![info exists 3xStatsStarted($channel)]} {
    set 3xStatsStarted($channel) [expr [clock seconds] - 1]
    if {[lsearch -exact [string tolower $3xStatsAutoVoteIgnoreChannels] [string tolower $channel]] == -1} {
      if {$3xUseStatsAutoVote} {
        timer [expr $3xStatsAutoVoteTimer + 1] [subst {3xStatsVoteStart $channel}]
      }
    }
  }
  if {![info exists 3xStatsNumberOfWordsInChannel($channel)]} { set 3xStatsNumberOfWordsInChannel($channel) 0 }
  if {![info exists 3xStatsWordsOfUsersInChannel($channel)]} { set 3xStatsWordsOfUsersInChannel($channel) {} }
  if {![info exists 3xStatsWordsInChannel($channel)]} { set 3xStatsWordsInChannel($channel) {} }
  if {![info exists 3xStatsUsersOnIgnoreInChannel($channel)]} { set 3xStatsUsersOnIgnoreInChannel($channel) {} }

  ##### Ignore any Bots!
  if {[matchattr $handle +b]} { return }

  ##### Ignore cheating Users!
  if {[lsearch -exact $3xStatsUsersOnIgnoreInChannel($channel) [maskhost $user]] > -1} { return }

  ##### Do some CheatProtection!
  ##### The following will ignore all Messages with when a single Word
  ##### is used more then 5x in the Message!
  set msg [3xRemoveDangerousChars $msg]
  if {[info exists tmpCount]} {
    unset tmpCount
  }
  foreach {w} $msg {
    if {[info exists tmpCount($w)]} {
      set tmpCount($w) [expr $tmpCount($w) + 1]
    }
    if {![info exists tmpCount($w)]} {
      set tmpCount($w) 1
    }
    if {$tmpCount($w) > 4} {
      set 3xStatsUsersOnIgnoreInChannel($channel) [concat $3xStatsUsersOnIgnoreInChannel($channel) [maskhost $user]]
      timer $3xStatsTimeForIgnore "3xRemoveUserFromStatsIgnore $channel $user"
      puthelp "NOTICE $nick :Sorry! You will be ignored for Stats in $channel for the next Minutes!"
      putlog "$3xLogo <=> $nick ([maskhost $user]) tries to cheat Stats in [string tolower $channel]!"
      return
    }
  }

  ##### Raise total Number of Words in the Channel!
  set 3xStatsNumberOfWordsInChannel($channel) [expr $3xStatsNumberOfWordsInChannel($channel) + [llength [split $msg " "]]]

  ##### Raise Counter for the current Nick in Channel!
  set found 0
  set i 0
  foreach {u c} $3xStatsWordsOfUsersInChannel($channel) {
    if {$u == [maskhost $user]} {
      set 3xStatsWordsOfUsersInChannel($channel) [lreplace $3xStatsWordsOfUsersInChannel($channel) [expr $i * 2] [expr ($i * 2) + 1] [maskhost $user] [expr $c + [llength [split $msg " "]]]]
      set 3xStatsNicksForHosts([maskhost $user]) $nick
      set found 1
      break
    }
    set i [expr $i + 1]
  }
  if {!$found} {
    set 3xStatsWordsOfUsersInChannel($channel) [concat $3xStatsWordsOfUsersInChannel($channel) [maskhost $user] [llength [split $msg " "]]]
    set 3xStatsNicksForHosts([maskhost $user]) $nick
  }

  ##### Raise Counter for every single Word of the current Message!
  foreach {word} $msg {
    if {[string length $word] < $3xStatsMinWordLength} { continue }

    ##### Ignore defined Patterns!
    set matched 0
    foreach {pattern} $3xStatsIgnoreWords {
      if {[string match [string tolower $pattern] [string tolower $word]]} {
        set matched 1
        break
      }
    }
    if {$matched} { continue }

    set word [string tolower $word]
    set found 0
    set i 0
    foreach {w c} $3xStatsWordsInChannel($channel) {
      if {$w == $word} {
        set 3xStatsWordsInChannel($channel) [lreplace $3xStatsWordsInChannel($channel) [expr $i * 2] [expr ($i * 2) + 1] $word [expr $c + 1]]
        set found 1
        break
      }
      set i [expr $i + 1]
    }
    if {!$found} {
      set 3xStatsWordsInChannel($channel) [concat $3xStatsWordsInChannel($channel) $word 1]
    }
  }

}
proc 3xShowStats {nick user handle channel msg} {
  global botnick 3xLogo 3xStatsNumberOfWordsInChannel 3xStatsStarted 3xStatsWordsOfUsersInChannel 3xStatsWordsInChannel 3xStatsTimerCheck 3xStatsIgnoreChannels 3xStatsLinkedBots  3xStatsNicksForHosts

  if {[lsearch -exact [string tolower $3xStatsIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xStatsLinkedBots { if {[handonchan $bot $channel]} { return } }

  set channel [string tolower $channel]

  ##### Check the Timer!
  if {![3xCheckTimer $channel stats [lindex [split $3xStatsTimerCheck :] 0] [lindex [split $3xStatsTimerCheck :] 1] $nick $handle]} { return }

  if {![info exists 3xStatsStarted($channel)]} { set 3xStatsStarted($channel) [expr [clock seconds] - 1] }
  if {![info exists 3xStatsNumberOfWordsInChannel($channel)]} { set 3xStatsNumberOfWordsInChannel($channel) 0 }
  if {![info exists 3xStatsWordsOfUsersInChannel($channel)]} { set 3xStatsWordsOfUsersInChannel($channel) {} }
  if {![info exists 3xStatsWordsInChannel($channel)]} { set 3xStatsWordsInChannel($channel) {} }

  ##### Build up sorted List and String for TopChatter!
  set tmpList {}
  foreach {u c} $3xStatsWordsOfUsersInChannel($channel) {
    set tmpList [concat $tmpList \{$u $c\}]
  }
  set tmpList [lsort -decreasing -integer -index 1 $tmpList]
  set tmpList [lrange $tmpList 0 2]
  foreach {l} $tmpList {
    if {[info exists topchatter]} {
      set topchatter "$topchatter, $3xStatsNicksForHosts([lindex $l 0]) ([lindex $l 1])"
    }
    if {![info exists topchatter]} {
      set topchatter "$3xStatsNicksForHosts([lindex $l 0]) ([lindex $l 1])"
    }
  }
  if {![info exists topchatter]} {
    set topchatter "none"
  }
  
  ##### Build up sorted List and String for TopWords!
  set tmpList {}
  foreach {w c} $3xStatsWordsInChannel($channel) {
    if {[string length $w] < 6} { continue; }
    set tmpList [concat $tmpList \{$w $c\}]
  }
  set tmpList [lsort -decreasing -integer -index 1 $tmpList]
  set tmpList [lrange $tmpList 0 2]
  foreach {l} $tmpList {
    if {[info exists topwords]} {
      set topwords "$topwords, [lindex $l 0] ([lindex $l 1])"
    }
    if {![info exists topwords]} {
      set topwords "[lindex $l 0] ([lindex $l 1])"
    }
  }
  if {![info exists topwords]} {
    set topwords "none"
  }
  
  ##### Build up sorted List and String for TopIdler!
  set tmpList {}
  set tmpNicks [chanlist $channel]
  set tmpBots [chanlist $channel +b]
  foreach {n} $tmpNicks {
    ##### Ignore the Bot itself!
    if {$n == $botnick} {
      continue
    }
    ##### Ignore all other Bots!
    set found 0
    foreach {b} $tmpBots {
      if {$b == $n} {
        set found 1
        break
      }
    }
    if {!$found} {
      set tmpList [concat $tmpList \{[3xReplaceDangerousChars $n] [getchanidle $n $channel]\}]
    }
  }
  set tmpList [lsort -decreasing -integer -index 1 $tmpList]
  set tmpList [lrange $tmpList 0 2]
  foreach {l} $tmpList {
    if {[info exists topidler]} {
      set topidler "$topidler, [lindex $l 0] ([lindex $l 1])"
    }
    if {![info exists topidler]} {
      set topidler "[lindex $l 0] ([lindex $l 1])"
    }
  }
  if {![info exists topidler]} {
    set topidler "none"
  }
  
  puthelp "PRIVMSG $channel :$3xLogo All Totals : [3xGetTimeString [expr [clock seconds] - $3xStatsStarted($channel)]] - $3xStatsNumberOfWordsInChannel($channel) Words ([format %.2f [expr $3xStatsNumberOfWordsInChannel($channel) /  ((([clock seconds] - $3xStatsStarted($channel)) / 60.0) + 0.0)]] per Minute)"
  puthelp "PRIVMSG $channel :$3xLogo TopChatter : $topchatter!"
  puthelp "PRIVMSG $channel :$3xLogo TopIdler \002\002 \002\002 : $topidler!"
  puthelp "PRIVMSG $channel :$3xLogo TopWords \002\002 \002\002 : $topwords!"
  putlog "$3xLogo <=> $nick ($handle) calls for Stats in [string tolower $channel]!"
}
proc 3xShowStatsForUser {nick user handle channel msg} {
  global botnick 3xLogo 3xStatsWordsOfUsersInChannel 3xStatsIgnoreChannels 3xStatsLinkedBots 3xStatsForUserTimerCheck

  if {[lsearch -exact [string tolower $3xStatsIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xStatsLinkedBots { if {[handonchan $bot $channel]} { return } }

  set channel [string tolower $channel]

  ##### Check the Timer!
  if {![3xCheckTimer $channel mystats [lindex [split $3xStatsForUserTimerCheck :] 0] [lindex [split $3xStatsForUserTimerCheck :] 1] $nick $handle]} { return }

  if {![info exists 3xStatsWordsOfUsersInChannel($channel)]} { set 3xStatsWordsOfUsersInChannel($channel) {} }

  ##### Build up sorted List and String for TopChatter!
  set tmpList {}
  if {[info exists tmpChatter]} { unset tmpChatter }
  foreach {u c} $3xStatsWordsOfUsersInChannel($channel) {
    set tmpList [concat $tmpList \{$u $c\}]
    if {$u == [maskhost $user]} {
      set tmpChatter [subst {$u $c}]
    }
  }
  set tmpList [lsort -decreasing -integer -index 1 $tmpList]
  if {![info exists tmpChatter]} {
    puthelp "NOTICE $nick :You don't have any Stats for this Channel!"
    return
  }
  set tmpChatterIndex [lsearch -exact $tmpList $tmpChatter]
  
  puthelp "PRIVMSG $channel :$3xLogo $nick, You're placed [expr $tmpChatterIndex + 1]. with a Total of [lindex $tmpChatter 1] Words!"
  putlog "$3xLogo <=> $nick ($handle) calls for MyStats in [string tolower $channel]!"
}
proc 3xResetStats {handle idx arg} {
  global 3xLogo 3xStatsNumberOfWordsInChannel 3xStatsStarted 3xStatsWordsOfUsersInChannel 3xStatsWordsInChannel 3xStatsUsersOnIgnoreInChannel

  set channel [string tolower [lindex $arg 0]]
  if {[string length $channel] < 2} {
    putdcc $idx "$3xLogo <=> You need to specify a valid Channel to reset Stats on!"
    return
  }
  if {![matchattr $handle m|m $channel]} {
    putdcc $idx "$3xLogo <=> You are no Master on $channel!"
    return
  }

  unset 3xStatsStarted($channel)
  unset 3xStatsNumberOfWordsInChannel($channel)
  unset 3xStatsWordsOfUsersInChannel($channel)
  unset 3xStatsWordsInChannel($channel)
  unset 3xStatsUsersOnIgnoreInChannel($channel)

  putlog "$3xLogo <=> $handle resets Stats in [string tolower $channel]!"
}
proc 3xRemoveUserFromStatsIgnore {channel user} {
  global 3xLogo 3xStatsUsersOnIgnoreInChannel

  set i [lsearch -exact $3xStatsUsersOnIgnoreInChannel($channel) [maskhost $user]]
  set 3xStatsUsersOnIgnoreInChannel($channel) [lreplace $3xStatsUsersOnIgnoreInChannel($channel) $i $i]

  putlog "$3xLogo <=> [maskhost $user] is no longer ignored for Stats in [string tolower $channel]!"
}
proc 3xStatsVoteStart {channel} {
  global botnick 3xStatsStarted 3xVoteRunning 3xStatsAutoVoteIgnoreChannels 3xStatsIgnoreChannels 3xStatsLinkedBots

  if {[lsearch -exact [string tolower $3xStatsIgnoreChannels] [string tolower $channel]] > -1} { return }
  if {[lsearch -exact [string tolower $3xStatsAutoVoteIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xStatsLinkedBots { if {[handonchan $bot $channel]} { return } }

  if {[info exists 3xVoteRunning($channel)]} {
    if {$3xVoteRunning($channel) == 0} {
      3xStartVote $botnick * * $channel "Stats running for [3xGetTimeString [expr [clock seconds] - $3xStatsStarted($channel)]] - should I reset?"
      timer 5 [subst {3xStatsVoteEnd $channel}]
      return
    }
    timer 5 [subst {3xStatsVoteStart $channel}]
    return
  }
  3xStartVote $botnick * * $channel "Stats running for [3xGetTimeString [expr [clock seconds] - $3xStatsStarted($channel)]] - should I reset?"
  timer 5 [subst {3xStatsVoteEnd $channel}]
}
proc 3xStatsVoteEnd {channel} {
  global botnick 3xLogo 3xStatsAutoVoteTimer 3xVotesYes 3xVotesNo 3xStatsStarted 3xStatsNumberOfWordsInChannel 3xStatsWordsOfUsersInChannel 3xStatsWordsInChannel 3xStatsUsersOnIgnoreInChannel

  if {$3xVotesYes($channel) > $3xVotesNo($channel)} {
    unset 3xStatsStarted($channel)
    unset 3xStatsNumberOfWordsInChannel($channel)
    unset 3xStatsWordsOfUsersInChannel($channel)
    unset 3xStatsWordsInChannel($channel)
    unset 3xStatsUsersOnIgnoreInChannel($channel)
    putlog "$3xLogo <=> Stats got reset do to Voting in [string tolower $channel]!"
    return
  }
  timer [expr $3xStatsAutoVoteTimer - 5] [subst {3xStatsVoteStart $channel}]
}
if {$3xUseStats} {
  bind PUBM -|- * 3xUpdateStats
  bind PUB -|- !stats 3xShowStats
  bind PUB -|- !mystats 3xShowStatsForUser
  bind DCC m|m resetstats 3xResetStats
}

##### Here the VotingSystem gets implemented. Use !vote to start a new Vote in a Channel.
##### All +o Users have Access in there Channel. All Users can vote to it via Channel or Query.
##### The Vote lasts 5 Minutes and can't be canceled.
proc 3xStartVote {nick user handle channel vote} {
  global 3xLogo 3xVoteQuestion 3xVoteChannel 3xVoteRunning 3xVotesYes 3xVotesNo 3xVotesIdents 3xVoteLinkedBots 3xVoteTimers

  foreach {bot} $3xVoteLinkedBots { if {[handonchan $bot $channel]} { return } }

  set channel [string tolower $channel]

  if {[info exists 3xVoteRunning($channel)]} {
    if {$3xVoteRunning($channel) == 1} {
      puthelp "NOTICE $nick :There is allready a Vote running in $channel! Please try again later!"
      return 0
    }
  }

  ##### Determine the Timer...
  if {[string first " " $vote] != -1} {
    set tmpTime [string range $vote 0 [expr [string first " " $vote] - 1]]
    if {[regexp -- \^\[0-9\]+\$ $tmpTime]} {
      set vote [string range $vote [expr [string first " " $vote] + 1] end]
    }
    if {![regexp -- \^\[0-9\]+\$ $tmpTime]} {
      set tmpTime 5
    }
  }
  if {![info exists tmpTime]} {
    set tmpTime 5
  }

  if {([string length $vote] < 1) || ([regexp -- \^\[0-9\]+\$ $vote])} {
      puthelp "NOTICE $nick :Please specify your Vote by using !vote [Minutes] <Question>!"
      return 0
  }  

  ##### Initialize all Variables...
  set 3xVoteRunning($channel) 1
  set 3xVoteQuestion($channel) $vote
  set 3xVotesYes($channel) 0
  set 3xVotesNo($channel) 0
  set 3xVotesIdents($channel) ""
  set 3xVoteTimers($channel) {}

  ##### Start all needed Timers...
  if {$tmpTime < 20} {
    for {set x 3} {$x < $tmpTime} {set x [expr $x + 3]} {
      set 3xVoteTimers($channel) [linsert $3xVoteTimers($channel) end [timer $x [subst {3xRemindVote $channel [expr $tmpTime - $x]}]]]
    }
    set 3xVoteTimers($channel) [linsert $3xVoteTimers($channel) end [timer $tmpTime [subst {3xEndVote $channel $nick $user $tmpTime}]]]
  }
  if {($tmpTime >= 20) && ($tmpTime < 120)} {
    for {set x 8} {$x < $tmpTime} {set x [expr $x + 8]} {
      set 3xVoteTimers($channel) [linsert $3xVoteTimers($channel) end [timer $x [subst {3xRemindVote $channel [expr $tmpTime - $x]}]]]
    }
    set 3xVoteTimers($channel) [linsert $3xVoteTimers($channel) end [timer $tmpTime [subst {3xEndVote $channel $nick $user $tmpTime}]]]
  }
  if {$tmpTime >= 120} {
    for {set x 20} {$x < $tmpTime} {set x [expr $x + 20]} {
      set 3xVoteTimers($channel) [linsert $3xVoteTimers($channel) end [timer $x [subst {3xRemindVote $channel [expr $tmpTime - $x]}]]]
    }
    set 3xVoteTimers($channel) [linsert $3xVoteTimers($channel) end [timer $tmpTime [subst {3xEndVote $channel $nick $user $tmpTime}]]]
  }

  puthelp "PRIVMSG $channel :$3xLogo Vote: $3xVoteQuestion($channel)"
  puthelp "PRIVMSG $channel :$3xLogo Use \002!yes\002 or \002!no\002 to submit your Vote! There are [3xGetTimeString [expr $tmpTime * 60]] left!"

  putlog "$3xLogo <=> $nick ($handle) started Vote in $channel!"
}
proc 3xRemindVote { channel time } {
  global 3xLogo 3xVoteQuestion 3xVoteChannel 3xVoteRunning 3xVotesYes 3xVotesNo 3xVotesIdents 3xVoteTimers
  puthelp "PRIVMSG $channel :$3xLogo Vote: $3xVoteQuestion($channel)"
  puthelp "PRIVMSG $channel :$3xLogo Use \002!yes\002 or \002!no\002 to submit your Vote! There are [3xGetTimeString [expr $time * 60]] left!"
  putlog "$3xLogo <=> Reminded on Vote in $channel!"
}
proc 3xEndVote { channel nick user time } {
  global 3xLogo 3xVoteQuestion 3xVoteChannel 3xVoteRunning 3xVotesYes 3xVotesNo 3xVotesIdents 3xVoteLogfile 3xVoteTimers
  puthelp "PRIVMSG $channel :$3xLogo Vote: $3xVoteQuestion($channel)"
  puthelp "PRIVMSG $channel :$3xLogo The Results are \002$3xVotesYes($channel)\002 yes -vs- \002$3xVotesNo($channel)\002 no!"

  set tmpFile [open $3xVoteLogfile a+]
  puts $tmpFile "[clock seconds]\t$channel\t$3xVoteQuestion($channel)\t$3xVotesYes($channel)\t$3xVotesNo($channel)\t$time\t$nick\t$user"
  close $tmpFile

  set 3xVoteRunning($channel) 0
  putlog "$3xLogo <=> Vote ended in $channel! Result got logged!"
}
proc 3xVoteYes {nick user handle channel msg} {
  global 3xLogo 3xVoteQuestion 3xVoteChannel 3xVoteRunning 3xVotesYes 3xVotesNo 3xVotesIdents 3xVoteTimers
  set channel [string tolower $channel]
  if {[matchattr $handle +b]} { return }
  if {![info exists 3xVoteRunning($channel)]} {
    return 0
  }
  if {$3xVoteRunning($channel) == 0} {
    return 0
  }
  if {[string first $user $3xVotesIdents($channel)] != -1} { return 0 }
  incr 3xVotesYes($channel)
  set 3xVotesIdents($channel) "$3xVotesIdents($channel) $user"
  puthelp "NOTICE $nick :Thanx for your Voting!"
  putlog "$3xLogo <=> $nick ($user) voted for YES in $channel!"
}
proc 3xVoteNo {nick user handle channel msg} {
  global 3xLogo 3xVoteQuestion 3xVoteChannel 3xVoteRunning 3xVotesYes 3xVotesNo 3xVotesIdents 3xVoteTimers
  set channel [string tolower $channel]
  if {[matchattr $handle +b]} { return }
  if {![info exists 3xVoteRunning($channel)]} {
    return 0
  }
  if {$3xVoteRunning($channel) == 0} {
    return 0
  }
  if {[string first $user $3xVotesIdents($channel)] != -1} { return 0 }
  incr 3xVotesNo($channel)
  set 3xVotesIdents($channel) "$3xVotesIdents($channel) $user"
  puthelp "NOTICE $nick :Thanx for your Voting!"
  putlog "$3xLogo <=> $nick ($user) voted for NO in $channel!"
}
proc 3xVoteYesMsg {nick user handle msg} {
  global 3xLogo 3xVoteQuestion 3xVoteChannel 3xVoteRunning 3xVotesYes 3xVotesNo 3xVotesIdents 3xVoteTimers
  if {[string first "#" $msg] == -1} {
    puthelp "PRIVMSG $nick :$3xLogo Please use \002!yes #channel\002 when voting via Query!"
    return 0
  }
  if {![info exists 3xVoteRunning([string tolower $msg])]} {
    puthelp "PRIVMSG $nick :$3xLogo There is no Vote running in [string tolower $msg]!"
    return 0
  }
  if {$3xVoteRunning([string tolower $msg]) == 0} {
    puthelp "PRIVMSG $nick :$3xLogo There is no Vote running in [string tolower $msg]!"
    return 0
  }
  if {[string first $user $3xVotesIdents([string tolower $msg])] != -1} {
    puthelp "PRIVMSG $nick :$3xLogo You allready voted on that!"
    return 0
  }
  3xVoteYes $nick $user $handle $msg "dummy"
}
proc 3xVoteNoMsg {nick user handle msg} {
  global 3xLogo 3xVoteQuestion 3xVoteChannel 3xVoteRunning 3xVotesYes 3xVotesNo 3xVotesIdents 3xVoteTimers
  if {[string first "#" $msg] == -1} {
    puthelp "PRIVMSG $nick :$3xLogo Please use \002!no #channel\002 when voting via Query!"
    return 0
  }
  if {![info exists 3xVoteRunning([string tolower $msg])]} {
    puthelp "PRIVMSG $nick :$3xLogo There is no Vote running in [string tolower $msg]!"
    return 0
  }
  if {$3xVoteRunning([string tolower $msg]) == 0} {
    puthelp "PRIVMSG $nick :$3xLogo There is no Vote running in [string tolower $msg]!"
    return 0
  }
  if {[string first $user $3xVotesIdents([string tolower $msg])] != -1} {
    puthelp "PRIVMSG $nick :$3xLogo You allready voted on that!"
    return 0
  }
  3xVoteNo $nick $user $handle $msg "dummy"
}
proc 3xKillVote {handle idx arg} {
  global 3xLogo 3xVoteQuestion 3xVoteChannel 3xVoteRunning 3xVotesYes 3xVotesNo 3xVotesIdents 3xVoteTimers
  
  set channel [string tolower [lindex $arg 0]]
  if {$channel == ""} {
    putdcc $idx "$3xLogo <=> You need to specify a Channel!"
    return
  }
  if {![info exists 3xVoteRunning($channel)]} {
    putdcc $idx "$3xLogo <=> There is no Vote running in $channel!"
    return
  }
  if {$3xVoteRunning($channel) == 0} {
    putdcc $idx "$3xLogo <=> There is no Vote running in $channel!"
    return
  }
  if {![matchattr $handle m|m $channel]} {
    putdcc $idx "$3xLogo <=> You are no Master for $channel!"
    return
  }
  
  foreach tmpTimer $3xVoteTimers($channel) {
    catch {
      killtimer $tmpTimer
    }
  }
  set 3xVoteRunning($channel) 0
  
  puthelp "PRIVMSG $channel :$3xLogo Vote: $3xVoteQuestion($channel)"
  puthelp "PRIVMSG $channel :$3xLogo The Vote got killed! No Results showing!"

  putlog "$3xLogo <=> $handle kills Vote in $channel!"
}
proc 3xStopVote {handle idx arg} {
  global 3xLogo 3xVoteQuestion 3xVoteChannel 3xVoteRunning 3xVotesYes 3xVotesNo 3xVotesIdents 3xVoteTimers
  
  set channel [string tolower [lindex $arg 0]]
  if {$channel == ""} {
    putdcc $idx "$3xLogo <=> You need to specify a Channel!"
    return
  }
  if {![info exists 3xVoteRunning($channel)]} {
    putdcc $idx "$3xLogo <=> There is no Vote running in $channel!"
    return
  }
  if {$3xVoteRunning($channel) == 0} {
    putdcc $idx "$3xLogo <=> There is no Vote running in $channel!"
    return
  }
  if {![matchattr $handle m|m $channel]} {
    putdcc $idx "$3xLogo <=> You are no Master for $channel!"
    return
  }
  
  foreach tmpTimer $3xVoteTimers($channel) {
    catch {
      killtimer $tmpTimer
    }
  }
  set 3xVoteRunning($channel) 0

  puthelp "PRIVMSG $channel :$3xLogo Vote: $3xVoteQuestion($channel)"
  puthelp "PRIVMSG $channel :$3xLogo The Vote got stopped at \002$3xVotesYes($channel)\002 yes -vs- \002$3xVotesNo($channel)\002 no!"
  
  putlog "$3xLogo <=> $handle stops Vote in $channel! Result not logged!"
}
if {$3xUseVote} {
  bind PUB V|V !vote 3xStartVote
  bind PUB -|- !yes 3xVoteYes
  bind PUB -|- !no 3xVoteNo
  bind MSG -|- !yes 3xVoteYesMsg
  bind MSG -|- !no 3xVoteNoMsg
  bind DCC m|m killvote 3xKillVote
  bind DCC m|m stopvote 3xStopVote
}

##### This one sends the Note to all Users with the specified Flag. This allows easy Usage
##### of Notes for Admins. The Notes-Module will be needed for that!
proc 3xSendNote {handle idx arg} {
  global 3xLogo
  set flags [lindex $arg 0]
  set matchedUsers [userlist $flags]
  foreach user $matchedUsers {
    if {[storenote $handle $user "[lrange $arg 1 end]" -1] == 0} {
      putdcc $idx "$3xLogo <=> Couldn't store Note for $user!"
    }
  }
  putlog "$3xLogo <=> $handle stored Note for [join $matchedUsers ","]!"
}
if {$3xUseMassNote} {
  bind DCC -|- massnote 3xSendNote
}

##### The following Block will deal with the Commands !url, !clan, !server, !email and !icq.
##### They are used to grep some Database for Lines matching at least one of the issued Keywords.
##### Additionally several Search-Features are supported like + and - Switches in Front of Strings!
proc 3xSearchDatabase {nick user handle channel db type args} {
  global 3xLogo 3xMaxEntriesToShowInChannel 3xMaxEntriesToShowInQuery 3xDatabaseTimerCheck
  
  if {$type == "channel"} {
    if {![3xCheckTimer $channel database [lindex [split $3xDatabaseTimerCheck :] 0] [lindex [split $3xDatabaseTimerCheck :] 1] $nick $handle]} { return }
  }
  
  set channel [string tolower $channel]
  
  ##### Try to match the Line!
  set tmpList {}
  set args [3xRemoveDangerousChars $args]
  regsub -all -- \\\? $args \\\\\? args
  set args [split $args " "]
  foreach {l} $db {

    set valid 0
    foreach {k} $args {

      ##### If the Keyword starts with + it MUST be found!
      if {[string first + $k] == 0} {
        set valid 1
        if {![string match [string tolower \*[string trimleft $k +]\*] [string tolower $l]]} {
          set valid 0
          break
        }
        continue
      }

      ##### If the Keyword starts with - it must NOT be found!
      if {[string first - $k] == 0} {
        set valid 1
        if {[string match [string tolower \*[string trimleft $k -]\*] [string tolower $l]]} {
          set valid 0
          break
        }
        continue
      }

      ##### Every other Keyword is might be matched!
      if {[string match [string tolower \*$k\*] [string tolower $l]]} {
          set valid 1
      }

    }
    if {$valid} {
      set tmpList [concat $tmpList \{$l\}]
    }
  }

  ##### Check if at least one got found!
  if {[llength $tmpList] == 0} {
    puthelp "NOTICE $nick :Sorry... found no Entry matching your Query!"
    return
  }

  ##### Check how many have been found!
  if {($type == "channel") && ([llength $tmpList] > $3xMaxEntriesToShowInChannel)} {
    set tmpCount [llength $tmpList]
    set tmpList [lrange $tmpList 0 [expr $3xMaxEntriesToShowInChannel - 1]]
    puthelp "NOTICE $nick :These are only the first $3xMaxEntriesToShowInChannel of $tmpCount Entries matching your Query! You might need to redefine your Search using + and - as Qualifiers! Displaying max $3xMaxEntriesToShowInChannel Entries in Channels and $3xMaxEntriesToShowInQuery in private Chat!"
  }
  if {($type == "query") && ([llength $tmpList] > $3xMaxEntriesToShowInQuery)} {
    set tmpCount [llength $tmpList]
    set tmpList [lrange $tmpList 0 [expr $3xMaxEntriesToShowInQuery - 1]]
    puthelp "NOTICE $nick :These are only the first $3xMaxEntriesToShowInChannel of $tmpCount Entries matching your Query! You might need to redefine your Search using + and - as Qualifiers! Displaying max $3xMaxEntriesToShowInChannel Entries in Channels and $3xMaxEntriesToShowInQuery in private Chat!"
  }

  ##### Print all found Results!
  if {$type == "channel"} {
    foreach {l} $tmpList {
      puthelp "PRIVMSG $channel :$3xLogo $l"
    }
    return
  }
  if {$type == "query"} {
    foreach {l} $tmpList {
      puthelp "PRIVMSG $nick :$3xLogo $l"
    }
    return
  }
}
proc 3xSearchUrl {nick user handle channel args} {
  global 3xLogo 3xDataUrl 3xUrlIgnoreChannels 3xUrlLinkedBots
  if {[lsearch -exact [string tolower $3xUrlIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xUrlLinkedBots { if {[handonchan $bot $channel]} { return } }
  3xSearchDatabase $nick $user $handle $channel $3xDataUrl "channel" $args
  putlog "$3xLogo <=> $nick ($handle) calls for !url in [string tolower $channel]!"
}
proc 3xSearchUrlQuery {nick user handle args} {
  global 3xLogo 3xDataUrl
  3xSearchDatabase $nick $user $handle "dummy" $3xDataUrl "query" $args
  putlog "$3xLogo <=> $nick ($handle) calls for !url in Query!"
}
proc 3xSearchClan {nick user handle channel args} {
  global 3xLogo 3xDataClan 3xClanIgnoreChannels 3xClanLinkedBots
  if {[lsearch -exact [string tolower $3xClanIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xClanLinkedBots { if {[handonchan $bot $channel]} { return } }
  3xSearchDatabase $nick $user $handle $channel $3xDataClan "channel" $args
  putlog "$3xLogo <=> $nick ($handle) calls for !clan in [string tolower $channel]!"
}
proc 3xSearchClanQuery {nick user handle args} {
  global 3xLogo 3xDataClan
  3xSearchDatabase $nick $user $handle "dummy" $3xDataClan "query" $args
  putlog "$3xLogo <=> $nick ($handle) calls for !clan in Query!"
}
proc 3xSearchEmail {nick user handle channel args} {
  global 3xLogo 3xDataEmail 3xEmailIgnoreChannels 3xEmailLinkedBots
  if {[lsearch -exact [string tolower $3xEmailIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xEmailLinkedBots { if {[handonchan $bot $channel]} { return } }
  3xSearchDatabase $nick $user $handle $channel $3xDataEmail "channel" $args
  putlog "$3xLogo <=> $nick ($handle) calls for !email in [string tolower $channel]!"
}
proc 3xSearchEmailQuery {nick user handle args} {
  global 3xLogo 3xDataEmail
  3xSearchDatabase $nick $user $handle "dummy" $3xDataEmail "query" $args
  putlog "$3xLogo <=> $nick ($handle) calls for !email in Query!"
}
proc 3xSearchIcq {nick user handle channel args} {
  global 3xLogo 3xDataIcq 3xIcqIgnoreChannels 3xIcqLinkedBots
  if {[lsearch -exact [string tolower $3xIcqIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xIcqLinkedBots { if {[handonchan $bot $channel]} { return } }
  3xSearchDatabase $nick $user $handle $channel $3xDataIcq "channel" $args
  putlog "$3xLogo <=> $nick ($handle) calls for !icq in [string tolower $channel]!"
}
proc 3xSearchIcqQuery {nick user handle args} {
  global 3xLogo 3xDataIcq
  3xSearchDatabase $nick $user $handle "dummy" $3xDataIcq "query" $args
  putlog "$3xLogo <=> $nick ($handle) calls for !icq in Query!"
}
proc 3xSearchServer {nick user handle channel args} {
  global 3xLogo 3xDataServer 3xServerIgnoreChannels 3xServerLinkedBots
  if {[lsearch -exact [string tolower $3xServerIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xServerLinkedBots { if {[handonchan $bot $channel]} { return } }
  3xSearchDatabase $nick $user $handle $channel $3xDataServer "channel" $args
  putlog "$3xLogo <=> $nick ($handle) calls for !server in [string tolower $channel]!"
}
proc 3xSearchServerQuery {nick user handle args} {
  global 3xLogo 3xDataServer
  3xSearchDatabase $nick $user $handle "dummy" $3xDataServer "query" $args
  putlog "$3xLogo <=> $nick ($handle) calls for !server in Query!"
}
proc 3xSearchCountry {nick user handle channel args} {
  global 3xLogo 3xDataCountry 3xCountryIgnoreChannels 3xCountryLinkedBots
  if {[lsearch -exact [string tolower $3xCountryIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xCountryLinkedBots { if {[handonchan $bot $channel]} { return } }
  3xSearchDatabase $nick $user $handle $channel $3xDataCountry "channel" $args
  putlog "$3xLogo <=> $nick ($handle) calls for !country in [string tolower $channel]!"
}
proc 3xSearchCountryQuery {nick user handle args} {
  global 3xLogo 3xDataCountry
  3xSearchDatabase $nick $user $handle "dummy" $3xDataCountry "query" $args
  putlog "$3xLogo <=> $nick ($handle) calls for !country in Query!"
}
proc 3xSearchWhat {nick user handle channel args} {
  global 3xLogo 3xDataWhat 3xWhatIgnoreChannels 3xWhatLinkedBots
  if {[lsearch -exact [string tolower $3xWhatIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xWhatLinkedBots { if {[handonchan $bot $channel]} { return } }
  3xSearchDatabase $nick $user $handle $channel $3xDataWhat "channel" $args
  putlog "$3xLogo <=> $nick ($handle) calls for !what in [string tolower $channel]!"
}
proc 3xSearchWhatQuery {nick user handle args} {
  global 3xLogo 3xDataWhat
  3xSearchDatabase $nick $user $handle "dummy" $3xDataWhat "query" $args
  putlog "$3xLogo <=> $nick ($handle) calls for !what in Query!"
}
proc 3xNotifyOnAdd {nick user handle channel args} {
  global 3xLogo 3xNotificationHandle 3xNotificationLinkedBots
  
  foreach {bot} $3xNotificationLinkedBots { if {[handonchan $bot $channel]} { return } }

  set msg [join $args " "]
  if {[string length $msg] < 1} {
    puthelp "NOTICE $nick :Please specify the Infos needed to insert the Data into the Database!"
    return
  }
  if {[storenote $3xNotificationHandle $3xNotificationHandle "$nick => $msg" -1] == 0} {
    puthelp "NOTICE $nick :Sorry... couldn't store your Note! Try again later!"
    return
  }
  puthelp "NOTICE $nick :Thanx for your Entry! The Admin will check and add it to the Database!"
  putlog "$3xLogo <=> $nick ($handle) announced a new Entry for the Database!"
}
proc 3xNotifyOnAddQuery {nick user handle args} {
  global 3xLogo 3xNotificationHandle
  
  set msg [join $args " "]
  if {[string length $msg] < 1} {
    puthelp "NOTICE $nick :Please specify the Infos needed to insert the Data into the Database!"
    return
  }
  if {[storenote $3xNotificationHandle $3xNotificationHandle "$nick => $msg" -1] == 0} {
    puthelp "NOTICE $nick :Sorry... couldn't store your Note! Try again later!"
    return
  }
  puthelp "NOTICE $nick :Thanx for your Entry! The Admin will check and add it to the Database!"
  putlog "$3xLogo <=> $nick ($handle) announced a new Entry for the Database!"
}
proc 3xDatabaseHelp {nick user handle channel args} {
  global 3xLogo 3xHelpLinkedBots
  
  foreach {bot} $3xHelpLinkedBots { if {[handonchan $bot $channel]} { return } }

  puthelp "NOTICE $nick :This Bot features \0023xBot.tcl\002! You can use the Commands !clan !url !server !email !icq !what !country !stats !mystats !topic !ltopic ?topic !calc and !idle - Use !add to announce new Entries for the Database!"

  putlog "$3xLogo <=> $nick ($handle) calls for !help in [string tolower $channel]!"
}
proc 3xDatabaseHelpQuery {nick user handle args} {
  global 3xLogo

  puthelp "NOTICE $nick :This Bot features \0023xBot.tcl\002! You can use the Commands !clan !url !server !email !icq !what !country !stats !mystats !topic !ltopic ?topic !calc and !idle - Use !add to announce new Entries for the Database!"

  putlog "$3xLogo <=> $nick ($handle) calls for !help in Query"
}
proc 3xAddEntryToDatabase {handle idx arg} {
  global 3xLogo 3xDataUrl 3xDataServer 3xDataClan 3xDataEmail 3xDataIcq 3xDataWhat 3xDataCountry 3xFileUrl 3xFileServer 3xFileClan 3xFileEmail 3xFileIcq 3xFileWhat 3xFileCountry 3xDatabaseLinkedBots

  set arg [3xRemoveDangerousChars $arg]

  set db [string tolower [lindex $arg 0]]
  if {($db != "url") && ($db != "clan") && ($db != "server") && ($db != "icq") && ($db != "email") && ($db != "what") && ($db != "country")} {
    putdcc $idx "$3xLogo <=> You need to specify the Database! Use url, clan, server, icq, email, what or country!"
    return
  }

  set msg [join [lrange $arg 1 end] " "]
  if {[string length $msg] < 1} {
    putdcc $idx "$3xLogo <=> You need to specify the new Entry!"
    return
  }

  if {$db == "url"} {
    file rename -force $3xFileUrl "$3xFileUrl.bak"
    set 3xDataUrl [concat $3xDataUrl \{$msg\}]
    set tmpFile [open $3xFileUrl w]
    puts -nonewline $tmpFile [join $3xDataUrl "\r\n"]
    close $tmpFile
  }  
  if {$db == "clan"} {
    file rename -force $3xFileClan "$3xFileClan.bak"
    set 3xDataClan [concat $3xDataClan \{$msg\}]
    set tmpFile [open $3xFileClan w]
    puts -nonewline $tmpFile [join $3xDataClan "\r\n"]
    close $tmpFile
  }  
  if {$db == "server"} {
    file rename -force $3xFileServer "$3xFileServer.bak"
    set 3xDataServer [concat $3xDataServer \{$msg\}]
    set tmpFile [open $3xFileServer w]
    puts -nonewline $tmpFile [join $3xDataServer "\r\n"]
    close $tmpFile
  }  
  if {$db == "email"} {
    file rename -force $3xFileEmail "$3xFileEmail.bak"
    set 3xDataEmail [concat $3xDataEmail \{$msg\}]
    set tmpFile [open $3xFileEmail w]
    puts -nonewline $tmpFile [join $3xDataEmail "\r\n"]
    close $tmpFile
  }  
  if {$db == "icq"} {
    file rename -force $3xFileIcq "$3xFileIcq.bak"
    set 3xDataIcq [concat $3xDataIcq \{$msg\}]
    set tmpFile [open $3xFileIcq w]
    puts -nonewline $tmpFile [join $3xDataIcq "\r\n"]
    close $tmpFile
  }  
  if {$db == "what"} {
    file rename -force $3xFileWhat "$3xFileWhat.bak"
    set 3xDataWhat [concat $3xDataWhat \{$msg\}]
    set tmpFile [open $3xFileWhat w]
    puts -nonewline $tmpFile [join $3xDataWhat "\r\n"]
    close $tmpFile
  }  
  if {$db == "country"} {
    file rename -force $3xFileCountry "$3xFileCountry.bak"
    set 3xDataCountry [concat $3xDataCountry \{$msg\}]
    set tmpFile [open $3xFileCountry w]
    puts -nonewline $tmpFile [join $3xDataCountry "\r\n"]
    close $tmpFile
  }  

  foreach tmpBot $3xDatabaseLinkedBots {
    catch {
      putbot $tmpBot "!3xReloadDatabase $db"
    }
  }

  putlog "$3xLogo <=> $handle added a new Entry to the Database!"
}
bind DCC m|- addentry 3xAddEntryToDatabase
proc 3xDelEntryFromDatabase {handle idx arg} {
  global 3xLogo 3xDataUrl 3xDataServer 3xDataClan 3xDataEmail 3xDataIcq 3xDataWhat 3xDataCountry 3xFileUrl 3xFileServer 3xFileClan 3xFileEmail 3xFileIcq 3xFileWhat 3xFileCountry 3xDatabaseLinkedBots

  set arg [3xReplaceDangerousChars $arg]

  set db [string tolower [lindex $arg 0]]
  if {($db != "url") && ($db != "clan") && ($db != "server") && ($db != "icq") && ($db != "email") && ($db != "what") && ($db != "country")} {
    putdcc $idx "$3xLogo <=> You need to specify the Database! Use url, clan, server, icq, email, what or country!"
    return
  }

  set msg [join [lrange $arg 1 end] " "]
  if {[string length $msg] < 1} {
    putdcc $idx  "$3xLogo <=> You need to specify the Entry to delete!"
    return
  }

  if {$db == "url"} {
    set i [lsearch -exact $3xDataUrl $msg]
    if {$i > -1} {
      file rename -force $3xFileUrl "$3xFileUrl.bak"
      set 3xDataUrl [lreplace $3xDataUrl $i $i]
      set tmpFile [open $3xFileUrl w]
      puts -nonewline $tmpFile [join $3xDataUrl "\r\n"]
      close $tmpFile
    }
    if {$i == -1} {
      putdcc $idx  "$3xLogo <=> This Entry couldn't be found in the Database!"
      return
    }
  }  
  if {$db == "clan"} {
    set i [lsearch -exact $3xDataClan $msg]
    if {$i > -1} {
      file rename -force $3xFileClan "$3xFileClan.bak"
      set 3xDataClan [lreplace $3xDataClan $i $i]
      set tmpFile [open $3xFileClan w]
      puts -nonewline $tmpFile [join $3xDataClan "\r\n"]
      close $tmpFile
    }
    if {$i == -1} {
      putdcc $idx  "$3xLogo <=> This Entry couldn't be found in the Database!"
      return
    }
  }  
  if {$db == "server"} {
    set i [lsearch -exact $3xDataServer $msg]
    if {$i > -1} {
      file rename -force $3xFileServer "$3xFileServer.bak"
      set 3xDataServer [lreplace $3xDataServer $i $i]
      set tmpFile [open $3xFileServer w]
      puts -nonewline $tmpFile [join $3xDataServer "\r\n"]
      close $tmpFile
    }
    if {$i == -1} {
      putdcc $idx "$3xLogo <=> This Entry couldn't be found in the Database!"
      return
    }
  }  
  if {$db == "email"} {
    set i [lsearch -exact $3xDataEmail $msg]
    if {$i > -1} {
      file rename -force $3xFileEmail "$3xFileEmail.bak"
      set 3xDataEmail [lreplace $3xDataEmail $i $i]
      set tmpFile [open $3xFileEmail w]
      puts -nonewline $tmpFile [join $3xDataEmail "\r\n"]
      close $tmpFile
    }
    if {$i == -1} {
      putdcc $idx "$3xLogo <=> This Entry couldn't be found in the Database!"
      return
    }
  }  
  if {$db == "icq"} {
    set i [lsearch -exact $3xDataIcq $msg]
    if {$i > -1} {
      file rename -force $3xFileIcq "$3xFileIcq.bak"
      set 3xDataIcq [lreplace $3xDataIcq $i $i]
      set tmpFile [open $3xFileIcq w]
      puts -nonewline $tmpFile [join $3xDataIcq "\r\n"]
      close $tmpFile
    }
    if {$i == -1} {
      putdcc $idx "$3xLogo <=> This Entry couldn't be found in the Database!"
      return
    }
  }  
  if {$db == "what"} {
    set i [lsearch -exact $3xDataWhat $msg]
    if {$i > -1} {
      file rename -force $3xFileWhat "$3xFileWhat.bak"
      set 3xDataWhat [lreplace $3xDataWhat $i $i]
      set tmpFile [open $3xFileWhat w]
      puts -nonewline $tmpFile [join $3xDataWhat "\r\n"]
      close $tmpFile
    }
    if {$i == -1} {
      putdcc $idx "$3xLogo <=> This Entry couldn't be found in the Database!"
      return
    }
  }  
  if {$db == "country"} {
    set i [lsearch -exact $3xDataCountry $msg]
    if {$i > -1} {
      file rename -force $3xFileCountry "$3xFileCountry.bak"
      set 3xDataCountry [lreplace $3xDataCountry $i $i]
      set tmpFile [open $3xFileCountry w]
      puts -nonewline $tmpFile [join $3xDataCountry "\r\n"]
      close $tmpFile
    }
    if {$i == -1} {
      putdcc $idx "$3xLogo <=> This Entry couldn't be found in the Database!"
      return
    }
  }  

  foreach tmpBot $3xDatabaseLinkedBots {
    catch {
      putbot $tmpBot "!3xReloadDatabase $db"
    }
  }

  putlog "$3xLogo <=> $handle deleted an Entry from the Database!"
}
bind DCC m|- delentry 3xDelEntryFromDatabase
proc 3xReloadDatabase {handle command arg} {
  global 3xLogo 3xDataUrl 3xDataServer 3xDataClan 3xDataEmail 3xDataIcq 3xDataWhat 3xDataCountry 3xFileUrl 3xFileServer 3xFileClan 3xFileEmail 3xFileIcq 3xFileWhat 3xFileCountry 3xDatabaseLinkedBots 3xUseUrl 3xUseServer 3xUseClan 3xUseEmail 3xUseIcq 3xUseWhat 3xUseCountry 
  
  if {($3xUseUrl == 1) && ($arg == "url")} {
    set tmpFile [open $3xFileUrl r]
    set 3xDataUrl [split [read $tmpFile] "\r\n"]
    close $tmpFile
  }
  if {($3xUseClan == 1) && ($arg == "clan")} {
    set tmpFile [open $3xFileClan r]
    set 3xDataClan [split [read $tmpFile] "\r\n"]
    close $tmpFile
  }
  if {($3xUseEmail == 1) && ($arg == "email")} {
    set tmpFile [open $3xFileEmail r]
    set 3xDataEmail [split [read $tmpFile] "\r\n"]
    close $tmpFile
  }
  if {($3xUseIcq == 1) && ($arg == "icq")} {
    set tmpFile [open $3xFileIcq r]
    set 3xDataIcq [split [read $tmpFile] "\r\n"]
    close $tmpFile
  }
  if {($3xUseServer == 1) && ($arg == "server")} {
    set tmpFile [open $3xFileServer r]
    set 3xDataServer [split [read $tmpFile] "\r\n"]
    close $tmpFile
  }
  if {($3xUseCountry == 1) && ($arg == "country")} {
    set tmpFile [open $3xFileCountry r]
    set 3xDataCountry [split [read $tmpFile] "\r\n"]
    close $tmpFile
  }
  if {($3xUseWhat == 1) && ($arg == "what")} {
    set tmpFile [open $3xFileWhat r]
    set 3xDataWhat [split [read $tmpFile] "\r\n"]
    close $tmpFile
  }

  putlog "$3xLogo <=> $handle forced Reload of [string toupper $arg] Database!"
}
bind BOT -|- !3xReloadDatabase 3xReloadDatabase
if {$3xUseUrl} {
  global 3xDataUrl
  set tmpFile [open $3xFileUrl r]
  set 3xDataUrl [split [read $tmpFile] "\r\n"]
  close $tmpFile
  bind PUB -|- !url 3xSearchUrl
  bind MSG -|- !url 3xSearchUrlQuery
}
if {$3xUseClan} {
  global 3xDataClan
  set tmpFile [open $3xFileClan r]
  set 3xDataClan [split [read $tmpFile] "\r\n"]
  close $tmpFile
  bind PUB -|- !clan 3xSearchClan
  bind MSG -|- !clan 3xSearchClanQuery
}
if {$3xUseEmail} {
  global 3xDataEmail
  set tmpFile [open $3xFileEmail r]
  set 3xDataEmail [split [read $tmpFile] "\r\n"]
  close $tmpFile
  bind PUB -|- !email 3xSearchEmail
  bind MSG -|- !email 3xSearchEmailQuery
}
if {$3xUseIcq} {
  global 3xDataIcq
  set tmpFile [open $3xFileIcq r]
  set 3xDataIcq [split [read $tmpFile] "\r\n"]
  close $tmpFile
  bind PUB -|- !icq 3xSearchIcq
  bind MSG -|- !icq 3xSearchIcqQuery
}
if {$3xUseServer} {
  global 3xDataServer
  set tmpFile [open $3xFileServer r]
  set 3xDataServer [split [read $tmpFile] "\r\n"]
  close $tmpFile
  bind PUB -|- !server 3xSearchServer
  bind MSG -|- !server 3xSearchServerQuery
}
if {$3xUseCountry} {
  global 3xDataCountry
  set tmpFile [open $3xFileCountry r]
  set 3xDataCountry [split [read $tmpFile] "\r\n"]
  close $tmpFile
  bind PUB -|- !country 3xSearchCountry
  bind MSG -|- !country 3xSearchCountryQuery
}
if {$3xUseWhat} {
  global 3xDataWhat
  set tmpFile [open $3xFileWhat r]
  set 3xDataWhat [split [read $tmpFile] "\r\n"]
  close $tmpFile
  bind PUB -|- !what 3xSearchWhat
  bind MSG -|- !what 3xSearchWhatQuery
}
if {$3xUseAddNotification} {
  bind PUB -|- !add 3xNotifyOnAdd
  bind MSG -|- !add 3xNotifyOnAddQuery
}
if {$3xUseHelp} {
  bind PUB -|- !help 3xDatabaseHelp
  bind MSG -|- !help 3xDatabaseHelpQuery
}

##### This one counts the ColorCodes used in a Message and kicks for using too much of them!
proc 3xColorKick {nick user handle channel args} {
  global 3xLogo 3xColorKickMaxColors 3xColorKickIgnoreChannels
  if {[lsearch -exact [string tolower $3xColorKickIgnoreChannels] [string tolower $channel]] > -1} { return }
  set s [join $args " "]
  if {[regsub -all --  $s "" s] > $3xColorKickMaxColors} {
    if {[matchattr $handle f|f $channel]} {
      puthelp "NOTICE $nick :Don't use that much Color! You might loose your +f for this Channel!"
      putlog "$3xLogo <=> $nick ($handle) uses too much Color in [string tolower $channel]... warned!"
      return
    }
    if ([botisop $channel]) {
      putkick $channel $nick "Don't use that much Color!"
      putlog "$3xLogo <=> $nick ($handle) uses too much Color in [string tolower $channel]... kicked!"
      return
    }
    putlog "$3xLogo <=> $nick ($handle) uses too much Color in [string tolower $channel]... can't kick 'cause i don't have @!"
  }
}
if {$3xUseColorKick} {
  bind PUBM -|- * 3xColorKick
}

##### Calc can be used to calculate some simple mathmematical Terms.
proc 3xCalc {nick user handle channel args} {
  global 3xLogo 3xCalcTimerCheck 3xCalcKickIgnoreChannels 3xCalcLinkedBots
  
  if {![3xCheckTimer $channel calc [lindex [split $3xCalcTimerCheck :] 0] [lindex [split $3xCalcTimerCheck :] 1] $nick $handle]} { return }
  if {[lsearch -exact [string tolower $3xCalcKickIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xCalcLinkedBots { if {[handonchan $bot $channel]} { return } }

  catch {
    puthelp "PRIVMSG $channel :$3xLogo [3xRemoveDangerousChars $args] = [expr [3xRemoveDangerousChars $args]]"
  }

  putlog "$3xLogo <=> $nick ($handle) calls for !calc in [string tolower $channel]!"
}
proc 3xCalcQuery {nick user handle args} {
  global 3xLogo

  catch {
    puthelp "PRIVMSG $nick :$3xLogo [3xRemoveDangerousChars $args] = [expr [3xRemoveDangerousChars $args]]"
  }

  putlog "$3xLogo <=> $nick ($handle) calls for !calc in Query"
}
if {$3xUseCalc} {
  bind PUB -|- !calc 3xCalc
  bind MSG -|- !calc 3xCalcQuery
}

##### Tells the actual Idle-Time of a User!
proc 3xIdle {nick user handle channel args} {
  global 3xLogo 3xIdleTimerCheck 3xIdleKickIgnoreChannels 3xIdleLinkedBots botnick
  
  if {![3xCheckTimer $channel idle [lindex [split $3xIdleTimerCheck :] 0] [lindex [split $3xIdleTimerCheck :] 1] $nick $handle]} { return }
  if {[lsearch -exact [string tolower $3xIdleKickIgnoreChannels] [string tolower $channel]] > -1} { return }
  foreach {bot} $3xIdleLinkedBots { if {[handonchan $bot $channel]} { return } }

  set n [lindex $args 0]
  if {![info exists n]} {
    puthelp "NOTICE $nick :You need to specify a NickName!"
    return
  }
  if {![onchan $n $channel]} {
    puthelp "NOTICE $nick :I don't see $n on [string tolower $channel]!"
    return
  }
  if {[string tolower $n] == [string tolower $botnick]} {
    puthelp "NOTICE $nick :Go and play with something else!"
    return
  }
  if {[string tolower $n] == [string tolower $nick]} {
    puthelp "NOTICE $nick :Go and play with something else!"
    return
  }

  puthelp "PRIVMSG $channel :$3xLogo $n is idling for [3xGetTimeString [expr 60 * [getchanidle $n $channel]]]!"

  putlog "$3xLogo <=> $nick ($handle) calls for !idle in [string tolower $channel]!"
}
if {$3xUseIdle} {
  bind PUB -|- !idle 3xIdle
}



###################################################################################################
###################################################################################################
###################################################################################################



##### This Procedure wil be used for all the TimeChecks for public Commands.
##### It deals with different Timers and controls the Usage of Commands in the Channel!
proc 3xCheckTimer {channel command count time nick handle} {
  global 3xTimerForCommand

  if {[string first m [chattr $handle $channel]] != -1} { return 1 }
  if {[string first n [chattr $handle $channel]] != -1} { return 1 }

  if {![info exists 3xTimerForCommand($channel\ $command)]} { set 3xTimerForCommand($channel\ $command) 0 }
  if {$3xTimerForCommand($channel\ $command) >= $count} {
    puthelp "NOTICE $nick :Keep waiting... Usage only $count times in $time Minutes!"
    return 0
  }
  set 3xTimerForCommand($channel\ $command) [expr $3xTimerForCommand($channel\ $command) + 1]
  timer $time "3xRemoveTimer $channel $command"
  return 1
}
proc 3xRemoveTimer {channel command} {
  global 3xTimerForCommand

  set 3xTimerForCommand($channel\ $command) [expr $3xTimerForCommand($channel\ $command) - 1]
}

proc 3xGetTimeString {seconds} {
  if {$seconds < 60} { return "a few Seconds" }
  set 3xTimeDays [format %i [expr $seconds / 86400]]
  set seconds [expr $seconds - (86400 * $3xTimeDays)]
  set 3xTimeHours [format %i [expr $seconds / 3600]]
  set seconds [expr $seconds - (3600 * $3xTimeHours)]
  set 3xTimeMinutes [format %i [expr $seconds / 60]]
  set 3xTimeString ""
  if {($3xTimeDays > 1) && ($3xTimeHours || $3xTimeMinutes)} {
    set 3xTimeString "$3xTimeDays Days, "
  }
  if {($3xTimeDays == 1) && ($3xTimeHours || $3xTimeMinutes)} {
    set 3xTimeString "$3xTimeDays Day, "
  }
  if {($3xTimeDays > 1) && !$3xTimeHours && !$3xTimeMinutes} {
    set 3xTimeString "$3xTimeDays Days"
  }
  if {($3xTimeDays == 1) && !$3xTimeHours && !$3xTimeMinutes} {
    set 3xTimeString "$3xTimeDays Day"
  }
  if {($3xTimeHours > 1) && $3xTimeMinutes} {
    set 3xTimeString "$3xTimeString $3xTimeHours Hours, "
  }
  if {($3xTimeHours == 1) && $3xTimeMinutes} {
    set 3xTimeString "$3xTimeString $3xTimeHours Hour, "
  }
  if {($3xTimeHours > 1) && !$3xTimeMinutes} {
    set 3xTimeString "$3xTimeString $3xTimeHours Hours"
  }
  if {($3xTimeHours == 1) && !$3xTimeMinutes} {
    set 3xTimeString "$3xTimeString $3xTimeHours Hour"
  }
  if {$3xTimeMinutes > 1} {
    set 3xTimeString "$3xTimeString $3xTimeMinutes Minutes"
  }
  if {$3xTimeMinutes == 1} {
    set 3xTimeString "$3xTimeString $3xTimeMinutes Minute"
  }
  return $3xTimeString
}

##### This one replaces all these dangerous Characters in Strings!
proc 3xReplaceDangerousChars {s} {
  regsub -all -- \\\\ $s \\\\\\\\ s
  regsub -all -- \\\[ $s \\\\\[ s
  regsub -all -- \\\] $s \\\\\] s
  regsub -all -- \\\} $s \\\\\} s
  regsub -all -- \\\{ $s \\\\\{ s
  regsub -all -- \\\" $s \\\\\" s
  if {[string first $s "\]"] == 0} { set s "\\\][string trimleft $s \]]" }
  if {[string last $s "\["] == [expr [string length $s] - 1]} { set s "[string trimright $s \[]\\\[" }
  return $s
}

##### This one replaces all these dangerous Characters in Strings!
proc 3xReplaceMostDangerousChars {s} {
  regsub -all -- \\\} $s \\\\\} s
  regsub -all -- \\\{ $s \\\\\{ s
  regsub -all -- \\\] $s \\\\\] s
  regsub -all -- \\\[ $s \\\\\[ s
  if {[string first $s "\]"] == 0} { set s "\\\][string trimleft $s \]]" }
  if {[string last $s "\["] == [expr [string length $s] - 1]} { set s "[string trimright $s \[]\\\[" }
  return $s
}

##### This one replaces all these dangerous Characters in Strings!
proc 3xReplaceDangerousSlashes {s} {
  regsub -all -- \\\\ $s \\\\\\\\ s
  return $s
}

##### This one removes all these dangerous Characters in Strings!
proc 3xRemoveDangerousChars {s} {
  regsub -all -- \\\\ $s "" s
  regsub -all -- \\\[ $s "" s
  regsub -all -- \\\] $s "" s
  regsub -all -- \\\} $s "" s
  regsub -all -- \\\{ $s "" s
  regsub -all -- \\\" $s "" s
  if {[string first $s "\]"] == 0} { set s [string trimleft $s \]] }
  if {[string last $s "\["] == [expr [string length $s] - 1]} { set s [string trimright $s \[] }
  return $s
}

##### This one removes all ColorCodes, Bolds and Co. from Strings!
proc 3xRemoveColorCodesAndCo {s} {
  regsub -all --  $s "" s
  regsub -all --  $s "" s
  regsub -all --  $s "" s
  regsub -all -- \[0-9\]\[0-9\],\[0-9\]\[0-9\] $s "" s
  regsub -all -- \[0-9\],\[0-9\]\[0-9\] $s "" s
  regsub -all -- \[0-9\]\[0-9\],\[0-9\] $s "" s
  regsub -all -- \[0-9\],\[0-9\] $s "" s
  regsub -all -- \[0-9\]\[0-9\] $s "" s
  regsub -all -- \[0-9\] $s "" s
  return $s
}

##### Just tests the two given Handles and returns 1 if the first submited has more or equal Rights than the second!
proc 3xCompareFlags {handle1 handle2 channel} {
  set s_max1 0
  set s_max2 0
  if {[matchattr $handle1 v|v $channel]} { set s_max1 1 }
  if {[matchattr $handle1 g|g $channel]} { set s_max1 2 }
  if {[matchattr $handle1 o|o $channel]} { set s_max1 3 }
  if {[matchattr $handle1 m|m $channel]} { set s_max1 4 }
  if {[matchattr $handle1 n|n $channel]} { set s_max1 5 }
  if {[matchattr $handle2 v|v $channel]} { set s_max2 1 }
  if {[matchattr $handle2 g|g $channel]} { set s_max2 2 }
  if {[matchattr $handle2 o|o $channel]} { set s_max2 3 }
  if {[matchattr $handle2 m|m $channel]} { set s_max2 4 }
  if {[matchattr $handle2 n|n $channel]} { set s_max2 5 }
  if {$s_max1 >= $s_max2} { return 1 }
  return 0
}

#proc xrange {xr xr1 xr2} {
#  return [join [lrange [split $xr] $xr1 $xr2]]
#}
#proc xindex {xr xr1} {
#  return [join [lrange [split $xr] $xr1 $xr1]]
#}

##### Load the HelpFile!
loadhelp 3xBot.help

##### Close with short Message!
putlog "$3xLogo v1.12 loaded! - TripleX <daniel.bleisteiner@berlin.de> - use \002.help 3xBot\002 for Infos!"
